#include <bits/stdc++.h>

using namespace std;
void ispisi(vector<long long> &niz,bool pov,vector<long long> &pom){
    long long kolko=1;
    for(long long i=0;i<niz.size();i++){
        kolko+=pom[i];
        cout<<niz[i]*kolko+(pov ? 1:0)<<" ";
    }
}
int main()
{
    long long n;
    cin>>n;
    long long k,x;
    cin>>k>>x;
    vector<long long> niz(n,1);
    vector<long long> pom(n,0);
    for(long long i=n-1;i>=0;i--){
        niz[i]=x+1;
        if(i<k){
            pom[i]++;
            k-=i;
            continue;
        }
        if(i==k){
            ispisi(niz,false,pom);
            return 0;
        }
        if(i>k){
            for(long long j=k;j<i;j++){
                niz[j]++;
            }
            ispisi(niz,true,pom);
            return 0;
        }
    //    ispisi(niz,false,pom);
    //    cout<<endl;
    }
    cout<<-1;
    return 0;
}